1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX2 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX3_TASK':TURBO_taskn 'EX3 v3.3':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX3_bas v3.3
1090 REMark 11 FEB 02
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250                         REMark **************************
1260 OPEN#4,con:wink%=GREEN%:REMark *  for drawing to screen *
1270                         REMark **************************
1280 :
1290 REMark                            **************************************
1300 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1310 REMark                            **************************************
1320 :
1330 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1340 :
1350 REMark ************************************************************
1360 REMark * We must set a primary window here if this is COMPILED.   *
1370 REMark * (PRPOS can be thought of as PRimary POSitioned).         *
1380 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1390 REMark * the window here must instead be "pulled down" as a       *
1400 REMark * secondary window.                                        *
1410 REMark ************************************************************
1420 :
1430                             REMark *******************
1440 SET_CHANNEL#4,SWIN(0,1,wwd):REMark * 2nd inf window  *
1450                             REMark *******************
1460 :
1470                 REMark **************************
1480 set_lim:        REMark * Set x/y wee/big for #4 *
1490 wron%=1:on_off: REMark * To set on/off to OFF   *
1500                 REMark **************************
1510 :
1520 REMark *******************************************************
1530 REMark * This is the repeat loop for reading the pointer and *
1540 REMark * taking apropriate action                            *
1550 REMark *******************************************************
1560 REPeat lp
1570  k=WRPTR(wwd)
1580  r=255&&get_x%(k)
1590  REMark ***************************************
1600  REMark * r is the code extracted from k      *
1610  REMark * 255 -> a loose item                 *
1620  REMark * 254 -> an event                     *
1630  REMark * otherwise the number of app. window *
1640  REMark *                                     *
1650  REMark * get_y%(k) is the bottom word of k   *
1660  REMark * and is the item or event number     *
1670  REMark ***************************************
1680  SELect ON r
1690   =255:REMark loose items
1700     IF do_loose%(get_y%(k)):EXIT lp
1710   =254:REMark event
1720     IF do_event%(get_y%(k)):EXIT lp
1730   =REMAINDER :REMark application window r
1740     IF do_app%(r,get_y%(k)):EXIT lp
1750  END SELect
1760 END REPeat lp
1770 STOP
1780 :
1790 DEFine PROCedure finish
1800  REMark *************************************************
1810  REMark * BUNST unsets the working definition           *
1820  REMark * BRCHP returns its area to the heap            *
1830  REMark * CLOS closes the channel opened for the window *
1840  REMark *************************************************
1850  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
1860  CLOSE#4
1870         REMark ***************************************************
1880  BRECHP:REMark * Returns the space used by the window definition *
1890         REMark ***************************************************
1900  STOP
1910 END DEFine
1920 :
1930 DEFine FuNction do_loose%(num%)
1940  REMark routine to do loose items
1950  LOCal k,ans%
1960  k=num%:ans%=0
1970  REMark ********************************************
1980  REMark * There are 5 loose items, numbered 0 to 4 *
1990  REMark * 0 = the move icon                        *
2000  REMark * 1 = the size icon                        *
2010  REMark * 2 = "ESC"                                *
2020  REMark * 3 = "Clear"                              *
2030  REMark * 4 = "OFF" or "ON"                        *
2040  REMark ********************************************
2050  SELect ON k
2060   =2:finish:ans%=1
2070   =1:do_size
2080   =0:mve
2090   =3:CLS#4
2100   =4:on_off:dloop:on_off
2110  END SELect
2120                             REMark **********************************
2130  IF NOT k=2:D_LDRW num%,wwd:REMark * Resets the item to "available" *
2140                             REMark **********************************
2150  RETurn ans%
2160 END DEFine
2170 :
2180 DEFine FuNction do_event%(num%)
2190  REMark ***********************************
2200  REMark * Each of these three events      *
2210  REMark * can also be accessed via the    *
2220  REMark * appropriate loose item          *
2230  REMark * 2 = quit, 8 = move, 16 = resize *
2240  REMark * When the action is done this    *
2250  REMark * returns 1 for stop, 0 for go on *
2260  REMark ***********************************
2270  LOCal as%
2280  as%=0
2290  IF 2&&num%:finish:as%=1
2300  IF 8&&num%:mve
2310  IF 16&&num%:do_size
2320  RETurn as%
2330 END DEFine
2340 :
2350 DEFine FuNction do_app%(wind%,num%)
2360  RETurn 0:REMark "go on"
2370 END DEFine
2380 :
2390 DEFine PROCedure do_size
2400  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2410  REMark ************************************************
2420  REMark * optr is the value to be used for PRPOS/PULLD *
2430  REMark *  It is the current window position plus its  *
2440  REMark *            "origin" plus its size.           *
2450  REMark *   The first comes from $24 of the working    *
2460  REMark *  definition (wwd) the second and third from  *
2470  REMark * the long words at 4 and $20 respectively of  *
2480  REMark * the window definition whose address is given *
2490  REMark *      at both wd(0) and PEEK_L(wwd+4).        *
2500  REMark                                                *
2510  REMark * Since the move icon is near the top left of  *
2520  REMark *   the window, we want to leave the bottom    *
2530  REMark * right corner as near its original position   *
2540  REMark *  as possible. We thus want to subtract the   *
2550  REMark * increase in size from the current "origin"   *
2560  REMark * position of the cursor. The increase is the  *
2570  REMark * current size less the new size. The value of *
2580  REMark * optr is adjusted later by subtracting the    *
2590  REMark *                 new size.                    *
2600  REMark ************************************************
2610  optr=PEEK_L(wwd+$24)+PEEK_L(wd(0)+4)+PEEK_L(wwd+$20)
2620                REMark *************************************
2630  mv=BCHSZ(wwd):REMark * mv is the reduction in size (x/y) *
2640                REMark *************************************
2650  xmv%=get_x%(mv):ymv%=get_y%(mv)
2660  REMark *************************************************
2670  REMark * We now have to check that the new size is     *
2680  REMark * within reasonable limits. It must be no       *
2690  REMark * bigger than the maximum in the window         *
2700  REMark * definition. It must be no smaller than the    *
2710  REMark * minimum size for this window layout.          *
2720  REMark * This size is used in M_SETUP to arrive at the *
2730  REMark * actual size.                                  *
2740  REMark * PEEK_L(wwd+32) is the current window size.    *
2750  REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2760  REMark * first window layout. Since this is variable   *
2770  REMark * we must eliminate the scaling flag ($4000)    *
2780  REMark * for both x and y values.                      *
2790  REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2800  REMark * window.                                       *
2810  REMark * Finally newx% must be made even (by ev%).     *
2820  REMark *************************************************
2830 :
2840  newx%=ev%(min%(PEEK_W(PEEK_L(wwd+4)),max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%)))
2850  newy%=min%(PEEK_W(PEEK_L(wwd+4)+2),max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%))
2860 :
2870  REMark *****************************************************
2880  REMark * BUNST unsets the working definition and throws    *
2890  REMark * away the window if NOT COMPILED.                  *
2900  REMark * BRCHP returns its area to the heap.               *
2910  REMark * CLOS closes the channel opened if not COMPILED.   *
2920  REMark * M_SETUP sets up the new working definition and    *
2930  REMark * gives us its address (in wwd).                    *
2940  REMark * M_PRPOS throws away the old window and sets up    *
2950  REMark * a new one. M_PULLD pulls down a secondary window. *
2960  REMark * All that remains is to reset #4, find the limits  *
2970  REMark * to this window via set_lim and to set on/off to   *
2980  REMark * OFF just as for a window move.                    *
2990  REMark *****************************************************
3000  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
3010  mv=newx%*2^16+newy%
3020  wwd=M_SETUP(#wch%,wd(0),mv)
3030 REMark *********************************************
3040 REMark * We use optr - mv to keep the bottom right *
3050 REMark *            corner stationary.             *
3060 REMark *********************************************
3070  IF COMPILED:chid=M_PRPOS(wwd,optr-mv):ELSE :chid=M_PULLD(wwd,optr-mv)
3080  SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off
3090  set_lim
3100 END DEFine
3110 :
3120 DEFine PROCedure mve
3130  REMark ***************************************
3140  REMark * On a move we must:                  *
3150  REMark *     1. reset #4                     *
3160  REMark *     2. set on/off -> OFF            *
3170  REMark *     3. reset the limits for drawing *
3180  REMark ***************************************
3190  BCHWIN wwd:SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off:set_lim
3200 END DEFine
3210 :
3220 DEFine PROCedure on_off
3230  REMark *******************************************
3240  REMark * This sets loose item 4 on<->off         *
3250  REMark * and sets wron%=1<->0.                   *
3260  REMark * wron%^^1 switches wron% between 0 and 1 *
3270  REMark * STLOB sets ON or OFF to loose item 4.   *
3280  REMark * g_txt returns the address of the text   *
3290  REMark * item number 2 or 3 ie "ON " or "OFF",   *
3300  REMark * (See EX3_text_list.)                    *
3310  REMark *******************************************
3320  STLOB 4,g_txt(wron%+2),wwd:wron%=wron%^^1
3330  D_LDRW 4,wwd
3340 END DEFine
3350 :
3360 DEFine PROCedure blk(w)
3370  LOCal px%,py%
3380  REMark **************************************
3390  REMark *  w is the pointer position.        *
3400  REMark *  A two by one block is drawn there *
3410  REMark *  provided it fits in #4.           *
3420  REMark **************************************
3430  px%=get_x%(w):py%=get_y%(w)
3440  IF xwee%<=px% AND px%<xbig%-1 AND ywee%<=py% AND py%<ybig%
3450   BLOCK#4,2,1,px%-xwee%,py%-ywee%,wink%
3460  END IF
3470 END DEFine
3480 :
3490 DEFine PROCedure dloop
3500  LOCal pptr,kk,lp
3510  REMark **********************************
3520  REMark * The pointer is read directly - *
3530  REMark * returning on a key stroke or a *
3540  REMark * key held down.                 *
3550  REMark **********************************
3560 :
3570  REMark *****************************************************
3580  REMark * First we set pptr to the current pointer position *
3590  REMark * Then via BRPTR we discover what key has been      *
3600  REMark * pressed and act accordingly.                      *
3610  pptr=WH_PTR(wwd):REMark * ex3 - Current pointer position   *
3620  REMark *****************************************************
3630  REPeat lp
3640   pptr=BRPTR(3,pptr,wwd): REMark * ex3 - new position       *
3650   kk=PEEK(PEEK_L(wwd)+18):REMark * ex3 - key stroke         *
3660   SELect ON kk
3670    =0,1:blk pptr
3680    =CODE('C'),CODE('c'):CLS#4
3690    =2:EXIT lp:       REMark * ex3 - Return to the main menu *
3700    =CODE('g'),CODE("G"):wink%=GREEN%:REMark * ex3 - These   *
3710    =CODE('r'),CODE("R"):wink%=RED%:  REMark * ex3 - set the *
3720    =CODE('w'),CODE("W"):wink%=WHITE%:REMark * ex3 - block   *
3730    =CODE('b'),CODE("B"):wink%=BLACK%:REMark * ex3 - colour  *
3740   END SELect
3750  END REPeat lp
3760 END DEFine
3770 :
3780 DEFine PROCedure set_lim
3790  LOCal ach
3800  REMark *********************************************************
3810  REMark * ex3 - ach is #4's base                                *
3820  REMark * ex3 - xwee%/ywee% is the top left extreme for a block *
3830  REMark * ex3 - xbig%/ybig% is the bottom right extreme         *
3840  REMark *********************************************************
3850  ach=CH_BAS(CHANNEL_ID(#4))
3860  xwee%=PEEK_W(ach+24):ywee%=PEEK_W(ach+26)
3870  xbig%=PEEK_W(ach+28)+xwee%:ybig%=PEEK_W(ach+30)+ywee%
3880 END DEFine
3890 :
19600 DATA 2186
19601 DATA 19,17747,17162,17260,25953,29194,20302,8202
19602 DATA 20294,17930,2567,18949,-23035,-5632,256,1541
19603 DATA 5633,32,0,10496,6656,5120,256,0
19604 DATA 3072,1,16384,2,29696,0,42,10752
19605 DATA 0,0,3,1023,-236,5247,32736,-8192
19606 DATA 4,1792,-108,-27520,-240,-4096,8,3840
19607 DATA -171,-11008,-248,-2048,17,7754,-19166,-7383
19608 DATA -10684,-17408,16,7936,-236,-2304,-252,-1024
19609 DATA 35,16146,-236,-2268,-158,-512,36,16286
19610 DATA -236,-2244,-110,-512,36,16274,-236,-2268
19611 DATA -110,-512,35,16146,-236,-2268,-158,-512
19612 DATA 64,32512,-236,-2304,-255,-256,64,32512
19613 DATA -236,-2304,-255,-256,84,27646,276,-2241
19614 DATA -16235,27392,40,14210,32020,30496,24458,30208
19615 DATA 40,14148,-17630,25361,28170,-2560,40,14120
19616 DATA -10462,25354,29962,-2560,16,7952,-4318,25348
19617 DATA 31492,-1024,16,7992,-14558,-7410,-3836,-1024
19618 DATA 16,7936,-191,-16128,-252,-1024,8,3840
19619 DATA -128,-32640,-248,-2048,4,1792,-128,-32640
19620 DATA -240,-4096,2,769,-256,64,32544,-8192
19621 DATA 1,258,-512,32,16192,-16384,0,130
19622 DATA -512,32,16256,-32768,0,124,31744,31
19623 DATA 7936,0,0,0,0,0,0,0
19624 DATA 3,1023,-194,15999,32736,-8192,7,2047
19625 DATA -100,-25345,-16,-4096,15,4095,-35,-8705
19626 DATA -8,-2048,31,8191,-1,-1,-4,-1024
19627 DATA 63,16383,-1,-1,-2,-512,63,16383
19628 DATA -1,-1,-2,-512,127,32767,-1,-1
19629 DATA -1,-256,127,32767,-1,-1,-1,-256
19630 DATA 127,32767,-1,-1,-1,-256,127,32767
19631 DATA -1,-1,-1,-256,255,-1,-1,-1
19632 DATA -1,-128,-32513,-1,-1,-1,-1,-128
19633 DATA -32513,-1,-1,-1,-1,-128,-32641,32767
19634 DATA -1,-1,-1,-256,127,32767,-9,-2049
19635 DATA -1,-256,127,32767,-9,-2049,-1,-256
19636 DATA 63,16383,-9,-2049,-2,-512,63,16383
19637 DATA -9,-2049,-2,-512,63,16383,-29,-7169
19638 DATA -2,-512,31,8191,-63,-15873,-4,-1024
19639 DATA 15,4095,-63,-15873,-8,-2048,7,2047
19640 DATA -128,-32513,-16,-4096,3,1023,-256,127
19641 DATA 32736,-8192,1,511,-256,127,32704,-16384
19642 DATA 0,254,-512,63,16256,-32768,0,124
19643 DATA 31744,31,7936,0,1,64,0,10496
19644 DATA 6656,5120,256,0,3072,1,16384,0
19645 DATA 0,0,42,10752,0,0,0,1
19646 DATA 384,-25408,-16384,0,0,1,341,-10944
19647 DATA -16384,0,0,2,853,-10976,-8192,0
19648 DATA 0,2,930,25504,24576,0,0,2
19649 DATA 788,-2272,-8192,0,0,2,950,-2144
19650 DATA -8192,0,0,2,981,-2144,-8192,0
19651 DATA 0,4,2005,-2160,-4096,0,0,4
19652 DATA 1974,-2160,-4096,0,0,2,788,-2272
19653 DATA -8192,0,0,2,788,-2272,-8192,0
19654 DATA 0,2,1015,5280,24576,0,0,2
19655 DATA 853,-18912,-8192,0,0,1,341,-18880
19656 DATA -16384,0,0,1,355,-21952,-16384,0
19657 DATA 0,1,355,-24000,-16384,0,0,1
19658 DATA 483,8896,16384,0,0,1,290,-7360
19659 DATA -16384,0,0,1,290,-7360,-16384,0
19660 DATA 0,0,193,-16000,-32768,0,0,0
19661 DATA 193,-16000,-32768,0,0,0,193,-16000
19662 DATA -32768,0,0,0,65,16640,0,0
19663 DATA 0,0,65,16640,0,0,0,0
19664 DATA 0,0,0,0,0,1,446,-16704
19665 DATA -16384,0,0,3,989,-8736,-8192,0
19666 DATA 0,3,1023,-32,-8192,0,0,7
19667 DATA 2047,-16,-4096,0,0,7,2047,-16
19668 DATA -4096,0,0,7,2047,-16,-4096,0
19669 DATA 0,7,2047,-16,-4096,0,0,7
19670 DATA 2047,-16,-4096,0,0,15,4095,-8
19671 DATA -2048,0,0,15,4095,-8,-2048,0
19672 DATA 0,7,2047,-16,-4096,0,0,7
19673 DATA 2047,-16,-4096,0,0,7,2047,-16
19674 DATA -4096,0,0,7,2047,-16,-4096,0
19675 DATA 0,3,1023,-32,-8192,0,0,3
19676 DATA 1023,-32,-8192,0,0,3,1015,-2080
19677 DATA -8192,0,0,3,1015,-2080,-8192,0
19678 DATA 0,3,1015,-2080,-8192,0,0,3
19679 DATA 1015,-2080,-8192,0,0,1,483,-7232
19680 DATA -16384,0,0,1,483,-7232,-16384,0
19681 DATA 0,1,483,-7232,-16384,0,0,0
19682 DATA 227,-7296,-32768,0,0,0,227,-7296
19683 DATA -32768,0,0,0,193,-16000,-32768,0
19684 DATA 1,32,0,1280,1280,512,512,0
19685 DATA 3072,0,7168,0,11264,0,32,8192
19686 DATA 80,20480,32,8192,0,0,32,8192
19687 DATA 112,28672,248,-2048,112,28672,32,8192
19688 DATA 1,64,0,2304,1792,1024,768,0
19689 DATA 3072,0,9216,0,0,0,8,2048
19690 DATA 20,5120,34,8704,20,5120,8,2048
19691 DATA 0,0,8,2048,28,7168,62,15872
19692 DATA 127,32512,62,15872,28,7168,8,2048
19693 DATA 0,5,-22015,0,0,2048,2560,0
19694 DATA 2304,0,0,0,2048,0,201,-14080
19695 DATA 146,-28160,146,-28160,146,-28160,202,-13824
19696 DATA 138,-30208,138,-30208,138,-30208,138,-30208
19697 DATA 209,-12032,0,2053,-506,7686,17926,28166
19698 DATA -27130,-16890,-6649,1543,9729,0,0,4096
19699 DATA 256,0,0,0,3072,0,0,0
19700 DATA 0,0,255,-1,-255,0,0,4096
19701 DATA 512,0,0,0,3072,0,0,0
19702 DATA 170,170,85,85,255,-1,-1,-1
19703 DATA -255,0,0,4096,512,0,0,0
19704 DATA 3072,0,0,0,0,-22016,-22016,21760
19705 DATA 22015,-1,-1,-1,-255,0,0,4096
19706 DATA 512,0,0,0,3072,0,0,0
19707 DATA 255,22015,22015,-21761,-21761,-1,-1,-1
19708 DATA -255,0,0,4096,512,0,0,0
19709 DATA 3072,0,0,0,85,-171,-86,-86
19710 DATA -1,-1,-1,-1,-255,0,0,4096
19711 DATA 512,0,0,0,3072,0,0,0
19712 DATA 170,-21846,-21931,21845,22015,-1,-1,-1
19713 DATA -255,0,0,4096,256,0,0,0
19714 DATA 3072,0,0,0,0,-256,-1,-1
19715 DATA -255,0,0,4096,256,0,0,0
19716 DATA 3072,0,0,0,255,255,255,-1
19717 DATA -255,0,0,4096,256,0,0,0
19718 DATA 3072,0,0,0,255,-1,-1,-1
19719 DATA -256,19760,2608,2605,12554,13106,12810,12597
19720 DATA 13578,13322,13322,12554,12810,11570,12810,14090
19721 DATA 12554,12554,12298,14090,13322,11569,2605,12554
19722 DATA 14090,12298,11569,2605,12554,12298,14090,11569
19723 DATA 2605,12554,12598,13625,12298,12598,13616,14602
19724 DATA 55,12554,12598,13367,12810,12598,2615,13322
19725 DATA 12298,12298,12298,12298,11569,14132,2609,13877
19726 DATA 13874,2609,13876,14384,2609,13322,12851,2608
19727 DATA 2610,2605,12596,2608,2560,-30156,2609,13834
19728 DATA 12596,2610,2609,2608,2608,2610,2608,2608
19729 DATA 2609,13834,12596,2610,12810,12554,12298,12298
19730 DATA 12810,12298,12554,12600,2609,13322,12598,13623
19731 DATA 12298,12554,12298,12298,12298,12298,12810,13104
19732 DATA 2609,13322,13362,2609,2608,2608,2605,12554
19733 DATA 13879,2611,2609,14346,12596,2609,13877,13368
19734 DATA 2609,2608,2608,2605,12554,14137,2612,2610
19735 DATA 2608,2609,2610,2609,2605,14090,11576,2605
19736 DATA 12554,11569,2560,1581,12554,11569,2560,813
19737 DATA 12554,0,0,0,0
19738 DATA 18510
